Debian Bug report logs - #646284
dropping applets-fallback breaks initramfs images

version graph

Package: busybox; Maintainer for busybox is Debian Install System Team <debian-boot@lists.debian.org>; Source for busybox is src:busybox.

Reported by: "Stefan Lippers-Hollmann" <s.L-H@gmx.de>

Date: Sat, 22 Oct 2011 21:51:01 UTC

Severity: grave

Tags: patch

Merged with 646285

Found in version busybox/1:1.19.2-1

Fixed in version busybox/1:1.19.2-2

Done: Michael Tokarev <mjt@tls.msk.ru>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-kernel@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#646284; Package busybox. (Sat, 22 Oct 2011 21:51:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Stefan Lippers-Hollmann" <s.L-H@gmx.de>:
New Bug report received and forwarded. Copy sent to debian-kernel@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>. (Sat, 22 Oct 2011 21:51:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Stefan Lippers-Hollmann" <s.L-H@gmx.de>
To: submit@bugs.debian.org
Subject: dropping applets-fallback breaks initramfs images
Date: Sat, 22 Oct 2011 23:49:28 +0200
[Message part 1 (text/plain, inline)]
Package: busybox
Version: 1:1.19.2-1
Severity: grave
Justification: Breaks system booting using initramfs-tools in non-trivial ways.
Tags: patch
X-Debbugs-CC: Debian kernel team <debian-kernel@lists.debian.org>

Hi

Initramfs images generated by initramfs-tools 0.99 after busybox got 
upgraded to 1:1.19.2-1 fail to boot with the following error messages:

Loading, please wait...
/init: line 11: mount: not found
/init: line 12: mount: not found
/init: line 25: mount: not found
W: devtmpfs not available, falling back to tmpfs for /devtmpfs
/init: line 25: mount: not found
/init: line 27: mount: not found
/init: line 28: mount: not found
cat: can't open '/proc/cmdline': No such file or directory
cat: can't open '/proc/cmdline': No such file or directory
/scripts/init-top/udev: line 14: can't create /sys/kernel/uevent_helper: nonexistent directory
Begin: Loading essential drivers ... done
Begin: Running /scripts/init-premount ... done
Begin: Mounting root file system .. Begin: Running /scripts/local-top .. [    0.742185] device-mapper: uevent: version 1.0.3
[    0.746854] device-mapper: ioctl 4.21.0-ioctl (2011-07-06) initialised: dm-devel@redhat.com
done.
Begin: Running /scripts/local-premount ... [     0.765009] Btrfs loaded
done.
/init: line 5: mount: not found
Begin: Running /scripts/local-bottom ... done
done.
Begin: Running /scripts/init-bottom ... done
/init: line 239: mv: not found
/init: line 239: umount: not found
/init: line 242: mount: not found
/init: line 243: mount: not found
Target filesystem doesn't have requested /sbin/init.
/init: line 291: chvt: not found
No init found. Try passing init= bootarg.


BusyBox v1.19.2 (Debian 1:1.19.2-1) built-in shell (ash)
Enter 'help' for a list of built-in commands.

/bin/sh: can't access tty; job control turned off
(initramfs)


needed initramfs-tools hooks on this system:

$ dpkg -S /usr/share/initramfs-tools/hooks/*
initramfs-tools: /usr/share/initramfs-tools/hooks/busybox
dmsetup: /usr/share/initramfs-tools/hooks/dmsetup
initramfs-tools: /usr/share/initramfs-tools/hooks/keymap
initramfs-tools: /usr/share/initramfs-tools/hooks/klibc
lvm2: /usr/share/initramfs-tools/hooks/lvm2
initramfs-tools: /usr/share/initramfs-tools/hooks/thermal
udev: /usr/share/initramfs-tools/hooks/udev

Re-instating applets-fallback.patch in busybox 1:1.19.2-1 however fixes
this reproducable boot failure, quick'n'dirty rediff (tested on 
amd64 && i386, using systems with mdadm, lvm2 or nothing special at 
all) attached.

Regards
	Stefan Lippers-Hollmann

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 3.1-rc10-aptosid-amd64 (SMP w/4 CPU cores; PREEMPT)
Locale: LANG=de_DE.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages busybox depends on:
ii  libc6  2.13-21

busybox recommends no packages.

busybox suggests no packages.

-- no debconf information
[applets-fallback.patch (text/x-patch, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#646284; Package busybox. (Sat, 22 Oct 2011 22:39:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Tokarev <mjt@tls.msk.ru>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. (Sat, 22 Oct 2011 22:39:05 GMT) Full text and rfc822 format available.

Message #10 received at 646284@bugs.debian.org (full text, mbox):

From: Michael Tokarev <mjt@tls.msk.ru>
To: Stefan Lippers-Hollmann <s.L-H@gmx.de>, 646284@bugs.debian.org
Subject: Re: Bug#646284: dropping applets-fallback breaks initramfs images
Date: Sun, 23 Oct 2011 02:36:20 +0400
On 23.10.2011 01:49, Stefan Lippers-Hollmann wrote:
> Package: busybox
> Version: 1:1.19.2-1
> Severity: grave
> Justification: Breaks system booting using initramfs-tools in non-trivial ways.
> Tags: patch
> X-Debbugs-CC: Debian kernel team <debian-kernel@lists.debian.org>
> 
> Hi
> 
> Initramfs images generated by initramfs-tools 0.99 after busybox got 
> upgraded to 1:1.19.2-1 fail to boot with the following error messages:
> 
> Loading, please wait...
> /init: line 11: mount: not found
...

Yes, applets-fallback was a dirty hack, and I tried to get rid of it,
and I asked kernel team several times about using regular ways to invoke
busybox commands in initramfs, but only got "Later" so far.  I tempted
to reassign this bug to initramfs-tools, but wont do that yet.

And no, it wasn't really expected - I hoped that CONFIG_FEATURE_PREFER_APPLETS
will take care of this.  Apparently not, and I wonder why it is so.....

.. ah, I see now: it is because initramfs does not put busybox as /bin/busybox
as it expects to be found, but copies it to /bin/sh.  So, with previously
applied applets-fallback, it tried to execute /proc/self/exe AND /bin/busybox,
and without that patch, it tries just /bin/busybox.  Sigh.

[]
> Re-instating applets-fallback.patch in busybox 1:1.19.2-1 however fixes
> this reproducable boot failure, quick'n'dirty rediff (tested on 
> amd64 && i386, using systems with mdadm, lvm2 or nothing special at 
> all) attached.

Thank you for the quick fix - something I tried to do yesterday but failed.

It is my intention to get rid of this ugly hack before wheezy, but unfortunately
kernel team does not want to cooperate.  So for now, I'll include this hack
again, and file a bug against initramfs-tools properly.

/mjt




Merged 646284 646285. Request was from Michael Tokarev <mjt@tls.msk.ru> to control@bugs.debian.org. (Sat, 22 Oct 2011 22:42:05 GMT) Full text and rfc822 format available.

Reply sent to Michael Tokarev <mjt@tls.msk.ru>:
You have taken responsibility. (Sat, 22 Oct 2011 23:21:06 GMT) Full text and rfc822 format available.

Notification sent to "Stefan Lippers-Hollmann" <s.L-H@gmx.de>:
Bug acknowledged by developer. (Sat, 22 Oct 2011 23:21:06 GMT) Full text and rfc822 format available.

Message #17 received at 646284-close@bugs.debian.org (full text, mbox):

From: Michael Tokarev <mjt@tls.msk.ru>
To: 646284-close@bugs.debian.org
Subject: Bug#646284: fixed in busybox 1:1.19.2-2
Date: Sat, 22 Oct 2011 23:17:32 +0000
Source: busybox
Source-Version: 1:1.19.2-2

We believe that the bug you reported is fixed in the latest version of
busybox, which is due to be installed in the Debian FTP archive:

busybox-static_1.19.2-2_i386.deb
  to main/b/busybox/busybox-static_1.19.2-2_i386.deb
busybox-syslogd_1.19.2-2_all.deb
  to main/b/busybox/busybox-syslogd_1.19.2-2_all.deb
busybox-udeb_1.19.2-2_i386.udeb
  to main/b/busybox/busybox-udeb_1.19.2-2_i386.udeb
busybox_1.19.2-2.debian.tar.gz
  to main/b/busybox/busybox_1.19.2-2.debian.tar.gz
busybox_1.19.2-2.dsc
  to main/b/busybox/busybox_1.19.2-2.dsc
busybox_1.19.2-2_i386.deb
  to main/b/busybox/busybox_1.19.2-2_i386.deb
udhcpc_1.19.2-2_all.deb
  to main/b/busybox/udhcpc_1.19.2-2_all.deb
udhcpd_1.19.2-2_all.deb
  to main/b/busybox/udhcpd_1.19.2-2_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 646284@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Michael Tokarev <mjt@tls.msk.ru> (supplier of updated busybox package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 23 Oct 2011 02:47:35 +0400
Source: busybox
Binary: busybox busybox-static busybox-udeb busybox-syslogd udhcpc udhcpd
Architecture: source all i386
Version: 1:1.19.2-2
Distribution: unstable
Urgency: low
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Changed-By: Michael Tokarev <mjt@tls.msk.ru>
Description: 
 busybox    - Tiny utilities for small and embedded systems
 busybox-static - Standalone rescue shell with tons of builtin utilities
 busybox-syslogd - Provides syslogd and klogd using busybox
 busybox-udeb - Tiny utilities for the debian-installer (udeb)
 udhcpc     - Provides the busybox DHCP client implementation
 udhcpd     - Provides the busybox DHCP server implementation
Closes: 450895 646284
Changes: 
 busybox (1:1.19.2-2) unstable; urgency=low
 .
   * resurrect applets-fallback.patch for now,
     thank you Stefan Lippers-Hollmann for the rediff.
     This restores the (broken) initramfs usage
     (Closes: #646284)
   * s/XC-Package-Type/Package-Type/ in debian/control (lintian)
   * add default build, build-arch and build-indep targets
     to debian/rules (lintian), and remove old maintainerclean
   * forgotten for 1.19: (Closes: #450895)
Checksums-Sha1: 
 ad27edd30565544c4599556d260720d18a0d9541 1576 busybox_1.19.2-2.dsc
 2a8f8a9e1d1a9529e9fad3df1c3556ceacc2911c 41890 busybox_1.19.2-2.debian.tar.gz
 4ffe093a17fe122bb835f8b3511bc7e56be53e8c 13838 udhcpc_1.19.2-2_all.deb
 aefd92f7376bd763ae5a826efd5e7fb7c43bb984 17122 udhcpd_1.19.2-2_all.deb
 2e9d3f481d31e5b8fb8427a83115ca2886c92e78 16174 busybox-syslogd_1.19.2-2_all.deb
 7ac8f6bffb91f0e13b5945f001e6efcde383a14f 779958 busybox-static_1.19.2-2_i386.deb
 23c920b55a57cade4604b06a273418eed1772a09 340240 busybox_1.19.2-2_i386.deb
 d71c8c3e123bfb00a49952a8d8b7af92b9f11019 165496 busybox-udeb_1.19.2-2_i386.udeb
Checksums-Sha256: 
 82b51d5ffc93a3861db11417bf7b2bbb14eca345f5874f93beabfa0b24e7c267 1576 busybox_1.19.2-2.dsc
 f4c21919f28fdab74d9ec3f2bf5d5b816c2ee82897516bf09ac5a933ec1ebd81 41890 busybox_1.19.2-2.debian.tar.gz
 4a843cab57744e69bace21a333154b4d24a8d2d4e88cec38547923d80d59cbab 13838 udhcpc_1.19.2-2_all.deb
 5d66aebecf9ac6eaaf72baf33bea9f3b375efefd89367cec3065a58a7e70d1fb 17122 udhcpd_1.19.2-2_all.deb
 c526382f6237d308855ab4e9b428eeaad9cf45ef89bf2358abb460425046a23a 16174 busybox-syslogd_1.19.2-2_all.deb
 5ade580400915826e7870f87746ffb55352763ede198c3fea994e738afa2d626 779958 busybox-static_1.19.2-2_i386.deb
 234cbd00b3f05df03dd4e0ec9e5ce228d8296768ee1625896624e525f1f4b970 340240 busybox_1.19.2-2_i386.deb
 8f0d6759e03000138195ec417988a5fbd1dcda639f0e2fdb6d06fbe30b5a97d0 165496 busybox-udeb_1.19.2-2_i386.udeb
Files: 
 b28178a621b1c6653ffd924b60d2a555 1576 utils optional busybox_1.19.2-2.dsc
 8f49d7593f8159d97212b294fcc96d44 41890 utils optional busybox_1.19.2-2.debian.tar.gz
 8774eb2522ab0dabf71fce2343f6bbef 13838 net optional udhcpc_1.19.2-2_all.deb
 621916e0b173c7040f256026e4b052ba 17122 net optional udhcpd_1.19.2-2_all.deb
 a7996263821852f1e397807c866d5b9f 16174 utils optional busybox-syslogd_1.19.2-2_all.deb
 c63b904a91f07abedbeeb3f2a7aaa0b9 779958 shells extra busybox-static_1.19.2-2_i386.deb
 3434d4ff9307a6cc571a40b5320741cb 340240 utils optional busybox_1.19.2-2_i386.deb
 088edb7f9a8c6a8b692e3ef9dc1994cb 165496 debian-installer extra busybox-udeb_1.19.2-2_i386.udeb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iJwEAQECAAYFAk6jStoACgkQUlPFrXTwyDhsdAP9Hk3itVEydh4IJx5Q2z4pJSYH
FNSqH0snRu+Li/VF2sKZ8ZqKV7iiuTh5JVcZ22P5ne1c4c2g/pJDIhFTmBa/iRjd
mcrOEY8zllvIy5Ls9iQ6idejrTeDOG/7w3tLe/jmFf4c16SRsNfWgzsZB4taNdCK
NkMqzEgPraFiiWRIpH0=
=1Csd
-----END PGP SIGNATURE-----





Reply sent to Michael Tokarev <mjt@tls.msk.ru>:
You have taken responsibility. (Sat, 22 Oct 2011 23:21:07 GMT) Full text and rfc822 format available.

Notification sent to Andre Tomt <andre@tomt.net>:
Bug acknowledged by developer. (Sat, 22 Oct 2011 23:21:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#646284; Package busybox. (Sun, 23 Oct 2011 06:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jörgen tegner <jteg68@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. (Sun, 23 Oct 2011 06:27:03 GMT) Full text and rfc822 format available.

Message #27 received at 646284@bugs.debian.org (full text, mbox):

From: Jörgen tegner <jteg68@gmail.com>
To: 646284@bugs.debian.org
Subject: How to fix a broken system
Date: Fri, 12 Aug 2011 08:31:29 +0200
Hi,

can you write down the steps required to get back to a bootable system?

Thanks,
Jörgen




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#646284; Package busybox. (Sun, 23 Oct 2011 07:01:42 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Tokarev <mjt@tls.msk.ru>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. (Sun, 23 Oct 2011 07:01:42 GMT) Full text and rfc822 format available.

Message #32 received at 646284@bugs.debian.org (full text, mbox):

From: Michael Tokarev <mjt@tls.msk.ru>
To: Jörgen tegner <jteg68@gmail.com>, 646284@bugs.debian.org
Subject: Re: Bug#646284: How to fix a broken system
Date: Sun, 23 Oct 2011 10:56:58 +0400
Um.  I almost missed this mail since it is dated 2 months ago...

On 12.08.2011 10:31, Jörgen tegner wrote:
> Hi,
> 
> can you write down the steps required to get back to a bootable system?

You'll have to boot from a cd-rom or using other alternative way,
eg, using an installation CD-rom, or some rescue-linux - anything
will do that lets you to mount chroot to your existing system.

Once there, update busybox package and regenerate initramfs images,
by running

 update-initramfs -k <yourkernelversion> -u

next umount (or just sync) and reboot.

You may also use previous busybox version (1.18.x, whatever) which may
still be in your /var/cache/apt/archives/ directory.

This is all true if you have only one kernel package installed.
If there are more than one, you may have good chance to have a
working system by booting another kernel, not only the one you
updated at the same time with busybox.

/mjt




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 21 Nov 2011 07:38:17 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 08:12:54 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.